Bug 1438842 - Review Request: matrix-synapse - a Matrix reference homeserver written in Python using Twisted
Summary: Review Request: matrix-synapse - a Matrix reference homeserver written in Py...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Randy Barlow
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-04-04 14:07 UTC by Jeremy Cline
Modified: 2017-11-01 22:22 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-11-01 22:22:37 UTC
randy: fedora-review+


Attachments (Terms of Use)
review_0.txt (14.06 KB, text/plain)
2017-05-16 14:16 UTC, Randy Barlow
no flags Details
review.txt (12.97 KB, text/plain)
2017-06-01 18:16 UTC, Randy Barlow
no flags Details

Description Jeremy Cline 2017-04-04 14:07:44 UTC
SRPM URL: https://jcline.fedorapeople.org/matrix-synapse-0.19.3-1.fc27.src.rpm
Spec URL: https://jcline.fedorapeople.org/matrix-synapse.spec
Description:
Matrix is an ambitious new ecosystem for open federated Instant Messaging and
VoIP. Synapse is a reference "homeserver" implementation of Matrix from the
core development team at matrix.org, written in Python/Twisted. It is intended
to showcase the concept of Matrix and let folks see the spec in the context of
a codebase and let you run your own homeserver and generally help bootstrap the
ecosystem.


Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=18780991
FAS: jcline

Comment 1 Jeremy Cline 2017-04-04 14:51:40 UTC
Updated to remove the python-pysaml2 < 4.0.0 requirement since there's already a python-pysaml2 >= 3.0.0 requirement.

SRPM URL: https://jcline.fedorapeople.org/matrix-synapse-0.19.3-2.fc27.src.rpm
Spec URL: https://jcline.fedorapeople.org/matrix-synapse.spec

Comment 2 Sayan Chowdhury 2017-04-19 15:37:21 UTC
This is an informal review. Can we fix the rpmlint errors?

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "*No copyright* Apache (v2.0)", "Unknown or
     generated", "*No copyright* Apache (v2)". 171 files have unknown
     license. Detailed output of licensecheck in /tmp/1438842-matrix-
     synapse/licensecheck.txt
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/systemd/system,
     /usr/lib/systemd
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 133120 bytes in 6 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[?]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: matrix-synapse-0.19.3-2.fc27.noarch.rpm
          matrix-synapse-0.19.3-2.fc27.src.rpm
matrix-synapse.noarch: W: spelling-error Summary(en_US) homeserver -> home server, home-server, whomever
matrix-synapse.noarch: W: summary-not-capitalized C a Matrix reference homeserver written in Python using Twisted
matrix-synapse.noarch: W: spelling-error %description -l en_US homeserver -> home server, home-server, whomever
matrix-synapse.noarch: W: spelling-error %description -l en_US codebase -> co debase, co-debase, code base
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/synctl.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/synctl.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/pusher.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/pusher.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/push/pusherpool.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/push/pusherpool.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/federation_reader.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/federation_reader.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/appservice.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/appservice.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/federation_sender.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/federation_sender.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/homeserver.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/homeserver.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/util/versionstring.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/util/versionstring.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/client_reader.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/client_reader.py 644 /usr/bin/env python
matrix-synapse.noarch: W: non-standard-uid /var/lib/synapse synapse
matrix-synapse.noarch: W: non-standard-gid /var/lib/synapse synapse
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/synchrotron.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/synchrotron.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/media_repository.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/media_repository.py 644 /usr/bin/env python
matrix-synapse.noarch: W: no-manual-page-for-binary synapse_port_db
matrix-synapse.noarch: W: no-manual-page-for-binary hash_password
matrix-synapse.noarch: W: no-manual-page-for-binary register_new_matrix_user
matrix-synapse.noarch: W: no-manual-page-for-binary synctl
matrix-synapse.src: W: spelling-error Summary(en_US) homeserver -> home server, home-server, whomever
matrix-synapse.src: W: summary-not-capitalized C a Matrix reference homeserver written in Python using Twisted
matrix-synapse.src: W: spelling-error %description -l en_US homeserver -> home server, home-server, whomever
matrix-synapse.src: W: spelling-error %description -l en_US codebase -> co debase, co-debase, code base
2 packages and 0 specfiles checked; 22 errors, 14 warnings.




Rpmlint (installed packages)
----------------------------
matrix-synapse.noarch: W: spelling-error Summary(en_US) homeserver -> home server, home-server, whomever
matrix-synapse.noarch: W: summary-not-capitalized C a Matrix reference homeserver written in Python using Twisted
matrix-synapse.noarch: W: spelling-error %description -l en_US homeserver -> home server, home-server, whomever
matrix-synapse.noarch: W: spelling-error %description -l en_US codebase -> co debase, co-debase, code base
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/appservice.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/appservice.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/client_reader.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/client_reader.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/federation_reader.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/federation_reader.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/federation_sender.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/federation_sender.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/homeserver.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/homeserver.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/media_repository.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/media_repository.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/pusher.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/pusher.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/synchrotron.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/synchrotron.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/app/synctl.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/app/synctl.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/push/pusherpool.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/push/pusherpool.py 644 /usr/bin/env python
matrix-synapse.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/synapse/util/versionstring.py /usr/bin/env python
matrix-synapse.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/synapse/util/versionstring.py 644 /usr/bin/env python
matrix-synapse.noarch: W: non-standard-uid /var/lib/synapse synapse
matrix-synapse.noarch: W: non-standard-gid /var/lib/synapse synapse
matrix-synapse.noarch: W: no-manual-page-for-binary hash_password
matrix-synapse.noarch: W: no-manual-page-for-binary register_new_matrix_user
matrix-synapse.noarch: W: no-manual-page-for-binary synapse_port_db
matrix-synapse.noarch: W: no-manual-page-for-binary synctl
1 packages and 0 specfiles checked; 22 errors, 10 warnings.


Requires
--------
matrix-synapse (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/python2
    config(matrix-synapse)
    py-bcrypt
    pyOpenSSL
    python(abi)
    python-bleach
    python-blist
    python-canonicaljson
    python-daemonize
    python-frozendict
    python-jinja2
    python-lxml
    python-matrix-synapse-ldap3
    python-msgpack
    python-netaddr
    python-pillow
    python-psutil
    python-pyasn1
    python-pydenticon
    python-pymacaroons-pynacl
    python-pynacl
    python-pysaml2
    python-service-identity
    python-signedjson
    python-systemd
    python-twisted
    python-ujson
    python-unpaddedbase64
    python-yaml
    shadow-utils



Provides
--------
matrix-synapse:
    config(matrix-synapse)
    matrix-synapse
    python2.7dist(matrix-synapse)
    python2dist(matrix-synapse)



Source checksums
----------------
https://github.com/matrix-org/synapse/archive/v0.19.3/synapse-v0.19.3.tar.gz :
  CHECKSUM(SHA256) this package     : cbcece1b5e2cd2b54256a5e6e1ab3337506a565eec9270ec7a7bfb83a85887a8
  CHECKSUM(SHA256) upstream package : cbcece1b5e2cd2b54256a5e6e1ab3337506a565eec9270ec7a7bfb83a85887a8


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1438842
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 3 Randy Barlow 2017-05-01 14:04:55 UTC
Igor, are you still planning to review this package? I'm willing to review it, but I don't want to step on your toes ☺

Comment 4 Randy Barlow 2017-05-16 14:16:23 UTC
Created attachment 1279342 [details]
review_0.txt

There are a few things to fix. In addition to the !'s, there are a few rpmlint things that would be easy to fix:

* s/homeserver/home server/
* Capitalize the summary.
* s/codebase/code base/

Comment 5 Jeremy Cline 2017-05-19 19:16:56 UTC
Thanks, I believe I covered everything except updating to the latest version since it introduces new dependencies that I need to package before upgrading.

Scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=19629006

SRPM URL: https://jcline.fedorapeople.org/matrix-synapse-0.19.3-3.fc27.src.rpm
Spec URL: https://jcline.fedorapeople.org/matrix-synapse.spec

Comment 6 Randy Barlow 2017-05-24 16:47:06 UTC
One more thing needs to be fixed for approval:

The macro used for /var/lib is still incorrect. It is currently %{_localstatedir}/lib, when it should be %{_sharedstatedir}.

Optional: The summary section still uses "homeserver" instead of "home server".

Comment 7 Sayan Chowdhury 2017-05-24 16:53:15 UTC
(In reply to Randy Barlow from comment #6)
> One more thing needs to be fixed for approval:
> 
> The macro used for /var/lib is still incorrect. It is currently
> %{_localstatedir}/lib, when it should be %{_sharedstatedir}.
+1

> 
> Optional: The summary section still uses "homeserver" instead of "home
> server".
matrix uses the term "homeserver" instead of "home server".

Comment 8 Jeremy Cline 2017-05-30 18:38:05 UTC
Okay, fixed the _sharedstatedir macro. I decided to uniformly use "homeserver" since that's what upstream uses.

Scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=19785375

SRPM URL: https://jcline.fedorapeople.org/matrix-synapse-0.19.3-4.fc27.src.rpm
Spec URL: https://jcline.fedorapeople.org/matrix-synapse.spec

Comment 9 Randy Barlow 2017-06-01 18:16:18 UTC
Created attachment 1284232 [details]
review.txt

Comment 10 Gwyn Ciesla 2017-06-02 12:34:07 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/matrix-synapse

Comment 11 fednuc 2017-06-10 12:57:14 UTC
This is fantastic that this is now in Fedora! Can I get clarification on whether it will be packaged for F25/F26?

https://admin.fedoraproject.org/pkgdb/package/rpms/matrix-synapse/ is showing it as approved for both of those releases but there's no apparent activity for those releases on https://apps.fedoraproject.org/packages/matrix-synapse

Thanks :)

Comment 12 Jeremy Cline 2017-06-12 13:07:09 UTC
(In reply to Stephen from comment #11)
> This is fantastic that this is now in Fedora! Can I get clarification on
> whether it will be packaged for F25/F26?
> 
> https://admin.fedoraproject.org/pkgdb/package/rpms/matrix-synapse/ is
> showing it as approved for both of those releases but there's no apparent
> activity for those releases on
> https://apps.fedoraproject.org/packages/matrix-synapse
> 
> Thanks :)

Hi Stephen,

It's been on my to-do list to see what needs to get updated/built in F26/25 for Synapse to be build-able, I just haven't gotten around to it yet. From what I remember, most dependencies were built in F26 so it shouldn't be too much of a challenge. I suspect F25 will be more troublesome, but we'll see.

I also need to package a few more dependencies before it can be updated to 0.20 so it may be a few weeks before that happens (even in rawhide).

Comment 13 Jeremy Cline 2017-06-12 14:18:35 UTC
Okay, it's built for Fedora 26!

Comment 14 fednuc 2017-06-12 18:05:21 UTC
Great, thanks :)

Comment 15 Adam Williamson 2017-11-01 21:43:09 UTC
Is there a reason this review request ticket is still open, if the review is complete and the package is imported?

Comment 16 Jeremy Cline 2017-11-01 22:22:37 UTC
Nope, I'm just sloppy. Sorry!


Note You need to log in before you can comment on or make changes to this bug.